#include "usgard.h"

HookLoc    = TEXT_MEM     ;Word for xy of hook
FishFight  = TEXT_MEM+2
Fish2Go    = TEXT_MEM+3   ;byte for the number of searchable fish.
CurDensity = TEXT_MEM+4   ;Current delay until density increase
Score      = TEXT_MEM+5
Time       = TEXT_MEM+6
Timer200   = TEXT_MEM+7
Keyhold    = TEXT_MEM+8
Fish       = TEXT_MEM+9  ;List- word for xyloc, byte for xdelta, byte for hooked
EOF        = TEXT_MEM+41


   .org 0
   .db  "Fishing 1.0",0

   ld   a,4
   out (5),a
   
   ld   a,(&GameSaved)
   or   a
   jr   z,Init
   ld   a,0
   ld   (&GameSaved),a
   ld   hl,&Save
   ld   de,TEXT_MEM
   ld   bc,42
   ldir
   jr   WheretoStart

Init:
   ld   hl,$3C20
   ld   (HookLoc),hl
   ld   a,60
   ld   (Time),a
StartGame:
   call CLEARLCD
   call &ZCPROUT
   ld   hl,&HighName
   ld   de,$0007
   ld   ($800C),de
   call D_ZT_STR
   ld   a,(&HighScore)
   ld   l,a
   ld   h,0
   call D_HL_DECI
   call OTH_PAUSE
WheretoStart:   
   ld   hl,&TimerCode
   call INT_INSTALL     ;timer starts now
GameLoop:   
   call &UI
   call &AddAFish
   call CLEARLCD
   call &DrawHookSet
   call &FishOnHook
   call &UpdateAllFish 
   ld   a,(Time)
   or   a
   call z,&EndGameOp
   ld   l,a
   ld   h,0
   ld   de,$3764
   ld   ($8333),de
   call DM_HL_DECI
   ld   a,(Score)
   ld   l,a
   ld   h,0
   ld   de,$3700
   ld   ($8333),de
   call DM_HL_DECI
   ld   b,10
   call &Delay
   jr   GameLoop

UI:
   call GET_KEY
   cp   K_SECOND
   jr   z,Snag
   cp   K_MORE
   jr   z,Reel_In
   cp   K_DEL
   jr   z,Reel_Out
   cp   K_F5
   jp   z,&ExitNow
   ret
Reel_In:
   ld   hl,HookLoc
   ld   a,(hl)
   cp   3
   ret  c
   dec  (hl)
   cp   6
   ret  nc
   ld   a,(FishFight)
   or   a
   ret  z
   ld   a,(Time)
   add  a,3
   ld   (Time),a
   ld   hl,Score
   inc  (hl)
   ld   e,2
   ld   a,8
   ld   (Fish2Go),a
   ld   hl,Fish
   call &SearchForFish
   inc  hl
   inc  hl
   inc  hl
   ld   a,0
   ld   (FishFight),a
   ld   (hl),a
   ret

Reel_Out:
   ld   hl,HookLoc
   ld   a,(hl)
   cp   55
   ret  nc
   inc  (hl)
   ret

Snag:
    call RANDOM
    and  %111
    ret  z
    ld   a,(FishFight)
    or   a
    ret  nz
    ld   a,8
    ld   (Fish2Go),a
    ld   hl,Fish
SnagSearch:    
    ld   e,1
    call &SearchForFish
    or   a
    ret  z
    ld   e,(hl)
    inc  hl
    ld   d,(hl)
    inc  hl
    ld   a,(HookLoc)
    add  a,5
    ld   c,a
    ld   a,(hl)
    cp   2
    jr   z,SRFish    
    ld   a,59
    sub  d
    cp   127
    jr   c,SLFNo
    cpl
SLFNo:
    cp   2
    jr   nc,ToSnagSearch
    jr   DepthCheck    
SRFish:    
    ld   a,d
    sub  66
    cp   127
    jr   c,SRFNo
    cpl
SRFNo:
    cp   2
    jr   nc,ToSnagSearch
DepthCheck:
    ld   a,e
    add  a,3
    sub  c
    cp   127
    jr   c,DCNo
    cpl
DCNo:
    cp   2
    jr   nc,ToSnagSearch    
    inc  hl
    ld   (hl),2
    call RANDOM
    and  %111111
    add  a,5
    ld   (FishFight),a
    ret
ToSnagSearch:   
   inc  hl
   inc  hl
   jr   SnagSearch

ExitNow:
   ld   de,&Save
   ld   hl,TEXT_MEM
   ld   bc,42
   ldir
   ld   a,1   
   ld   (&GameSaved),a
   call INT_REMOVE      ;timer stops now
   call OTH_EXIT

EndGameOp:   
   call INT_REMOVE      ;timer stops now
   call CLEARLCD
   ld   hl,&Catch
   ld   de,0
   ld   ($800C),de
   call D_ZT_STR
   ld   a,(Score)
   ld   l,a
   ld   h,0
   call D_HL_DECI
   ld   a,(Score)
   ld   b,a
   ld   a,(&HighScore)
   cp   b
   ld   a,b
   jr   nc,NoHigh
   ld   (&HighScore),a
   ld   hl,$0001
   ld   ($800C),hl
   ld   hl,&NewHigh
   call D_ZT_STR
   call &NameHandle
NoHigh:   
   call OTH_PAUSE
   call OTH_EXIT

TimerCode:
   ld   a,(Timer200)
   inc  a
   ld   (Timer200),a
   cp   200
   ret  nz
   ld   hl,Time
   dec  (hl)
   ret


DrawHookSet:
    ld   bc,(HookLoc)
    inc  b
    inc  b
    inc  b
    push bc
    ld   c,3
    ld   a,64    
    sub  c
    ld   c,a
    call FIND_PIXEL
    ld   de,$FC00
    add  hl,de
    ld   de,16
    pop  bc
    ld   b,c   
    ld   c,a
LineLoop:
    ld   a,c
    or   (hl)
    ld   (hl),a
    add  hl,de
    djnz LineLoop
    ld   hl,&HookPic
    ld   bc,(HookLoc)
    #fncall PSPR_W     ;*******
    ret 

FishOnHook:
    ld   a,(FishFight)
    or   a
    ret  z
    dec  a
    ld   (FishFight),a
    or   a
    jr   nz,dispFish
    ld   a,8
    ld   (Fish2Go),a
    ld   e,2
    ld   hl,Fish
    call &SearchForFish
    or   a
    ret  z
    ld   bc,(HookLoc)   
    ld   (hl),c
    inc  hl
    ld   (hl),b
    inc  hl
    inc  hl
    ld   (hl),1
    ret
dispFish:    
    ld   bc,(HookLoc)  
    ld   a,b
    add  a,4
    ld   b,a
    ld   a,c
    add  a,4
    ld   c,a
    ld   hl,&FishH
    #fncall PSPR_W     ;*******
    ret


AddAFish:
    ld   a,(CurDensity)
    or   a
    jr   z,OKToAdd
    dec  a
    ld   (CurDensity),a
    ret
OKToAdd:
    ld   a,8
    ld   (Fish2Go),a
    ld   e,0
    ld   hl,Fish
    call &SearchForFish
    or   a
    ret  z
    push hl
    call RANDOM
    and  31
    add  a,18
    pop  hl     
    ld   (hl),a 
    inc  hl     
    and  1
    jr   z,RBound
    ld   (hl),1
    inc  hl
    ld   (hl),1
    jr   LBound
RBound:
    ld   (hl),119
    inc  hl
    ld   (hl),2
LBound:
    inc  hl
    ld   (hl),1
    ld   a,16
    ld   (CurDensity),a
    ret
UpdateAllFish:
    ld   a,8
    ld   (Fish2Go),a
    ld   e,1
    ld   hl,Fish
UpdateLoop:    
    call &SearchForFish
    or   a
    ret  z
    push hl
    ld   c,(hl)
    inc  hl
    ld   b,(hl)
    inc  hl
    ld   d,(hl)
    pop  hl
    ld   a,d
    cp   1
    jr   z,RBnd
    dec  b
    dec  b
RBnd:    
    inc  b
    ld   a,b
    cp   120
    jr   z,ClearThisFish
    cp   0
    jr   z,ClearThisFish
    jr   Update
ClearThisFish:    
    ld   e,0
Update:
    ld   (hl),c
    inc  hl
    ld   (hl),b
    inc  hl
    ld   (hl),d
    inc  hl
    ld   (hl),e
    inc  hl
    push hl
    ld   a,d
    cp   1
    jr   z,FishIsR
    ld   hl,&FishL
    jr   DFish
FishIsR:    
    ld   hl,&FishR
DFish:
    #fncall PSPR_W     ;*******
    pop  hl
    ld   e,1
    jr   UpdateLoop
   
SearchForFish:
   ld   a,(Fish2Go)
   ld   b,a
   or   a
   ret  z
SearchLoop:
   inc  hl
   inc  hl
   inc  hl
   ld   a,(hl)
   cp   e
   jr   z,Found
   inc  hl
   djnz SearchLoop
   ld   a,0
   ld   (Fish2Go),a   
   ret
Found:
   dec  hl
   dec  hl
   dec  hl
   dec  b
   ld   a,b
   ld   (Fish2Go),a
   ld   a,1
   ret


Delay:   
   push bc
   ld   b,255
Inner:
   call GET_KEY
   cp   K_EXIT
   call z,&EndGameOp
   or   a
   jr   z,nokey
   ld   (Keyhold),a
nokey:   
   djnz Inner
   pop  bc
   djnz Delay
   ld   a,(Keyhold)   
   call STORE_KEY
   ld   a,0
   ld   (Keyhold),a
   ret

   
NameHandle:   
   ld   hl,&HighName
   ld   b,0
InitLoop:
;-----------------------------------------------------------------------------
;GetLetter: gets a letter(magnus hagander) <modified for usg.>
;-----------------------------------------------------------------------------
GetLetter:
  push hl
  push bc
  ld   hl,&ASCII_Table-1
ConvertLoop:
  push hl
  CALL GET_KEY
  pop  hl
  and  a
  jr   z,ConvertLoop
  cp   K_LEFT
  jr   z,Backsp
  cp   9
  jr   z,ENTER
  push hl
  ld   b,a
  ld   c,0
ConversionLoop:
  inc  hl
  djnz ConversionLoop          ;After this, we have the correct offset...
  ld   a,(HL)
  pop  hl
  and  a
  jr   z,ConvertLoop           ;Invalid key
  call TX_CHARPUT              ;Show the char
  pop  bc
  pop  hl
  inc  b
  ld   (hl),a
  ld   a,b
  cp   8
  jr   z,EOL
  inc  hl
  jr   InitLoop
END_IT:
  ld   a,b
  cp   8
  jr   nz,aas
  inc  hl
aas:   
  ld   (hl),0   
;  pop  hl
  ret
NOTH:
  pop  hl
  ret
EOL:
  ld   a,($800D)
  dec  a
  ld   ($800D),a
IOI:   
  push hl
  call GET_KEY
  pop  hl
  cp   K_LEFT
  jr   z,EB
  cp   9
  jr   z,END_IT
  jr   IOI
EB:
  ld   a,' '
  call TR_CHARPUT
  dec  b
  jr   InitLoop
Backsp:
  pop  bc
  pop  hl
  ld   a,b
  cp   0
  jr   z,InitLoop
  dec  hl
  ld   a,($800D)
  dec  a
  ld   ($800D),a
  dec  b
  ld   a,' '
  call TR_CHARPUT
  jr   InitLoop
ENTER:
  pop  bc
  pop  hl
  jr   END_IT

ZCPROUT:
        DI
        ld      HL,$FFFF
        xor     A
        ld      (HL),A
        ld      DE,$FFFE
        ld      BC,$03FF
        lddr
        exx
        ld      HL,&ZCP
        ld      C,$80
Loop:
        ld      A,(HL)
        inc     HL
        ld      D,A
        or      A
        jr      Z,EndDecode
        rlca
        jr      C,Copy
Stream:
        ld      A,D
        and     $3F
        ld      B,A
        ld      A,D
        and     $40
StreamLoop:
        or      A
        jr      Z,SLSuite
        ex      AF,AF'
        ld      A,C
        exx
        or      (HL)
        ld      (HL),A
        exx
        ex      AF,AF'
SLSuite:
        srl     C
        jr      NC,DjnzSL
        exx
        inc     HL
        exx
        ld      C,$80
DjnzSL:
        djnz    StreamLoop
        jr      Loop
Copy:
        ld      B,$07
CopyLoop:
        rlca
        jr      NC,CLSuite
        ex      AF,AF'
        ld      A,C
        exx
        or      (HL)
        ld      (HL),A
        exx
        ex      AF,AF'
CLSuite:
        srl     C
        jr      NC,DjnzCL
        exx
        inc     HL
        exx
        ld      C,$80
DjnzCL:
        djnz    CopyLoop
        jr      Loop
EndDecode:
        exx
        EI
        ret

GameSaved:
   .db  0

Save:
   .dw  $0000,$0000,$0000,$0000,$0000
   .dw  $0000,$0000,$0000,$0000,$0000
   .dw  $0000,$0000,$0000,$0000,$0000
   .dw  $0000,$0000,$0000,$0000,$0000
   .dw  $0000

HighName:
   .db  "MIKE",0,0,0,0,0

ASCII_Table:                  
  .db 0,0,0,0,0,0,0,0,0       
  .db 'X','T','O','J','E'      
  .db 0,0                     
  .db ' ','W','S','N','I'     
  .db 'D'                     
  .db 0,0                     
  .db 'Z','V','R','M','H','C' 
  .db 0,0                     
  .db 'Y','U','Q','L','G','B' 
  .db 0,0,0,0                 
  .db 'P','K','F','A'         
  .db 0,0,0,0,0,0,0,0,0,0,0   

HighScore:
   .db  0

ZCP: ;FishPic:

      .db   $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$2B,$C0,$3F,$3A,$C0
      .db    $3F,$3A,$C0,$3F,$3A,$C0,$3F,$3A,$C0,$3F,$1E,$C6,$15,$C0,$31,$C6
      .db    $25,$EF,$15,$C0,$8F,$F8,$23,$EF,$25,$48,$14,$C0,$88,$2A,$48,$24
      .db    $EF,$15,$C0,$88,$2A,$EF,$25,$C6,$08,$C0,$81,$09,$C0,$27,$C6,$1E
      .db    $C0,$0F,$E0,$81,$09,$C0,$3F,$0D,$C0,$0F,$E0,$81,$09,$C0,$1A,$4A
      .db    $28,$C0,$0F,$D0,$81,$09,$C0,$1A,$C0,$08,$C0,$0A,$C0,$C0,$84,$13
      .db    $C8,$81,$09,$C0,$1A,$C0,$08,$C0,$09,$C0,$A0,$82,$08,$C0,$82,$A0
      .db    $84,$80,$C0,$1A,$C0,$08,$C0,$08,$C0,$90,$81,$09,$C0,$82,$90,$84
      .db    $80,$C0,$1A,$C0,$08,$C0,$81,$C0,$88,$80,$C0,$88,$08,$C2,$81,$09
      .db    $C0,$1A,$C0,$08,$C0,$82,$0A,$C0,$84,$80,$C0,$82,$88,$84,$80,$C0
      .db    $1A,$C0,$08,$C0,$84,$0A,$4C,$09,$C0,$82,$84,$84,$80,$C0,$1A,$C0
      .db    $08,$C0,$88,$0A,$C0,$84,$80,$C0,$82,$84,$84,$80,$C0,$1A,$C3,$F0
      .db    $A0,$82,$0B,$C0,$84,$80,$C0,$82,$82,$84,$80,$C1,$FE,$13,$FC,$08
      .db    $C0,$83,$0A,$C0,$84,$80,$C0,$82,$81,$84,$80,$C0,$84,$13,$C0,$08
      .db    $C0,$80,$C0,$88,$80,$C0,$88,$08,$C0,$A1,$09,$C0,$84,$13,$C0,$08
      .db    $C0,$08,$C0,$90,$81,$09,$C0,$82,$80,$C4,$80,$C0,$88,$13,$C0,$08
      .db    $C0,$09,$E0,$A0,$82,$08,$C0,$82,$08,$C8,$81,$09,$C0,$10,$C0,$08
      .db    $C0,$0B,$C1,$0A,$C0,$88,$08,$C0,$89,$09,$C0,$90,$13,$C0,$08,$C0
      .db    $0A,$C0,$C0,$84,$80,$C0,$82,$09,$D0,$81,$80,$C0,$11,$C0,$08,$C0
      .db    $09,$C0,$A0,$82,$08,$C0,$82,$0A,$E0,$81,$82,$17,$C0,$08,$C0,$08
      .db    $C0,$90,$81,$09,$C0,$82,$0A,$E0,$80,$C2,$17,$C0,$08,$C0,$81,$C0
      .db    $88,$80,$C0,$88,$08,$C0,$81,$0D,$C8,$16,$C0,$08,$C0,$82,$1F,$C0
      .db    $82,$1A,$D0,$15,$C0,$08,$C0,$84,$1F,$C0,$82,$1B,$C0,$14,$C0,$08
      .db    $C0,$88,$1F,$C0,$82,$36,$C0,$08,$C0,$90,$1F,$C0,$82,$36,$C0,$3F
      .db    $3F,$3F,$34,$7F,$7D,$3F,$3F,$81,$F4,$DF,$8F,$CF,$DE,$FB,$EB,$C0
      .db    $08,$FE,$C4,$93,$F8,$BE,$A1,$9F,$9F,$90,$A2,$A8,$84,$84,$A9,$A5
      .db    $95,$8F,$BF,$90,$91,$C4,$C0,$88,$88,$C4,$84,$A4,$88,$FA,$81,$81
      .db    $8A,$AF,$A5,$BA,$81,$84,$86,$B3,$90,$82,$81,$91,$81,$89,$82,$92
      .db    $FC,$A0,$BE,$FA,$8F,$A8,$C0,$A1,$BA,$CA,$E7,$F0,$FC,$A8,$BE,$BE
      .db    $A0,$C4,$D0,$88,$8B,$92,$C2,$8A,$9F,$88,$A2,$F2,$E9,$09,$C0,$A8
      .db    $A0,$A8,$A0,$84,$DF,$8F,$C8,$D2,$C2,$8B,$C1,$88,$A2,$CA,$A9,$09
      .db    $C0,$90,$A0,$A4,$3A,$FC,$A1,$F8,$A0,$87,$F0,$FC,$90,$BE,$A2,$A0
      .db    $00


Catch:
   .db  "Fish collected:",0

NewHigh:;123456789012345678901
   .db  "New High! Type your  "
   .db  "name:",0


FishR:   
   .db  8,5
   .db  %10001100
   .db  %11011110
   .db  %11111111
   .db  %11011110
   .db  %10001100

FishL:   
   .db  8,5
   .db  %00110001
   .db  %01111011
   .db  %11111111
   .db  %01111011
   .db  %00110101

FishH:
   .db  8,8
   .db  %0001000
   .db  %0011100
   .db  %0111110
   .db  %0111110
   .db  %0011100
   .db  %0001000
   .db  %0011100
   .db  %0111110



HookPic:   
   .db  8,7
   .db  %00010000
   .db  %00101000
   .db  %00010000
   .db  %00010000
   .db  %00010000
   .db  %00100010
   .db  %00011100
   
   
   
   .END
